<?

class ParserNode extends BaseObject {

var $d_type;
var $d_params;

function ParserNode($type) {
parent::BaseObject();
$this->d_type = $type;
$this->d_params = array();
}

function getTagType() {
return $this->d_type;
}

function setProperties($value) {
$this->d_params = $value;
}

function getProperties() {
return $this->d_params;
}

}

/**
 *                                 
 *                
 **/
class ParserTag extends ParserNode {

var $d_keyname;
var $d_parts;

function ParserTag($type) {
parent::ParserNode($type);
$this->d_keyname = "";
$this->d_parts = array();
}

function setKeyname($value) {
$this->d_keyname = $value;
}

function getKeyname() {
return $this->d_keyname;
}

function setParts(&$values) {
$this->d_parts =& $values;
}

function &getParts() {
return $this->d_parts;
}
}

class ParserSplitter extends ParserNode {

function ParserSplitter($type) {
parent::ParserNode($type);
}
}

class ParserMessage extends EMessage {

function ParserMessage($message = "", $detailMessage = "") {
parent::EMessage($message, $detailMessage);
}
}

class ObjectParser extends BaseObject {

var $d_keyname;
var $d_type;
var $d_parser=NULL;

function ObjectParser() {
$this->d_keyname = "";
$this->d_type = "";
}

function setType($type) {
$this->d_type = $type;
}

function getType() {
return $this->d_type;
}

function setKeyname($keyname) {
$this->d_keyname = $keyname;
}

function getKeyname() {
return $this->d_keyname;
}

function &getParser() 
{
return $this->d_parser;
}
function setParser( &$parser )
{
$this->d_parser =& $parser;
}

function addCodePart($keyname, $code, $params) {}

function clearCodeParts() {}

function keyExists() { return true; }

function parse($input, $props) { return new NodeException("Not Implemented."); }

function checkCodeParts($keynames) { return false; }

function setCodeParts($parts) { }
}

?>
