<?
$title = ($translation) ? i18n("translation_page") . ": " . $name : $name;
echo dialog($f,0,"normal",$title,$ICO_PAGE);
?>
<script type="text/javascript">
jQuery(document).ready(function() {
	getSyncInfo();
});

function getSyncInfo() {
	// check the page's sync status
	jQuery.ajax({
		url : '<?=$PORTLETAPP_PREFIX;?>rest/page/load/<?=$PAGE_ID;?>?sid=<?=$SID;?>&translationstatus=true',
		type : 'GET',
		dataType : 'json', 
		success : function(data) {
			if (!data.page.translationStatus || !data.page.translationStatus.pageId) {
				// no translation status received - exiting
				return;				
			}
			var t = data.page.translationStatus;
			showSyncInfo(t);
		}
	});
}

function showSyncInfo(syncInfo) {
	// find the syncinfo cell
	var syncInfoCell = jQuery('td#syncinfo');
	if (!syncInfoCell[0]) {
		// not found, so create it
		jQuery('.dialog>table tr:last').after('<tr><td><?=i18n("Translation");?></td><td id="syncinfo"></td></tr>');
		syncInfoCell = jQuery('td#syncinfo');
	}

	// clear the cell first
	syncInfoCell.empty();

	// insert the sync info
	syncInfoCell.append('<p><?=i18n("translation_linked_to");?> ' +
			'<img style="vertical-align: -4px;" src="/.Node/?do=14203&module=content&base=doc.png&lang=' + syncInfo.language + '" alt="' + 
			syncInfo.name +'"/> ' + syncInfo.name + ' ('+syncInfo.language+' <?=i18n("Version")?> ' + syncInfo.version + ') </p>');
	// sync button (only if out of sync)
	if (!syncInfo.inSync) {
		var buttonSrc = '?do=15&amp;text=<?=i18n("Synchronize");?> (<?=i18n("Version")?> ' + syncInfo.latestVersion.version +')';
		syncInfoCell.append('<input id="syncbtn" type="image" src="'+buttonSrc+'" ' +
			'title="<?=i18n("Synchronize");?>" alt="<?=i18n("Synchronize");?>" border="0"/>');
		jQuery('#syncbtn').click(function() {
			debugger;
			var saveRequestBody = {
				page : {
					id : <?=$PAGE_ID;?>,
					translationStatus : {
						pageId : syncInfo.pageId,
						versionTimestamp : syncInfo.latestVersion.versionTimestamp
					}
				}
			};
			// save the page with new sync info
			jQuery.ajax({
				url : '<?=$PORTLETAPP_PREFIX;?>rest/page/save/<?=$PAGE_ID;?>?sid=<?=$SID;?>',
				type : 'POST',
				dataType : 'json',
				contentType: 'application/json; charset=utf-8',
				data : jQuery.toJSON(saveRequestBody),
				success : function(data) {
					getSyncInfo();
				}
			});

			return false;
		});
	}
}

</script>
