<?

//                                                                             
function trigger_event($event, $val, $reaction_id = -1) {

global $W_EVENT, $FEATURE, $W_REACTION, $DEBUG, $EVENT_IS_HANDLED;

if (!$FEATURE["workflow"]) return false;

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "<br>--- trigger_event($event,$reaction_id) ---<br>"; var_dump($val); echo "<br><br>"; }

//                                         
 //                                                                 
 if(!$FEATURE['event_disable_prehandle'] && is_array($EVENT_IS_HANDLED)) {
foreach($EVENT_IS_HANDLED as $handledEvent) {
//                           
 //                                            
 if(count(array_diff($val, $handledEvent['val'])) === 0) {
if($DEBUG["echo"] && $DEBUG["workflow"]) { echo "<br>----- Event was already handled. returning true.<br><br>"; }
return true;
}
}
}

$sql = "SELECT COUNT(*) AS c FROM triggerevent WHERE keyword = \"".sqlslashes($event)."\" AND templateevent_id > 0";
$rs = query($sql);//            
 if ($rs["arr"][0]["c"] == 0) return false;

$input = complete_event_vals($event, $val);
if (!is_array($input)) return false;

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "completed to:<br>"; var_dump($input); echo "<br><br>"; }

reset($input);
$events = array();
while (list($k,$value) = each($input)) {
$values = expand_event_vals($event, $value);
if ($values === FALSE) {
continue;
}

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "expanded to: <br>"; var_dump($values); echo "<br><br>"; }

$matched = match_events($event, $values, $reaction_id);
reset($matched);
while (list($event_id, $values) = each($matched)) {
$events[$event_id][] = $values;
if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "matched event: $event_id<br><br>"; }
}
}
$handled = false;

while (list($event_id,$values) = each($events)) {

//                                                                                       
 $sql = "SELECT reaction.id, reaction.keyword, triggerevent.workflowlink_id FROM reaction,triggerevent WHERE reaction.triggerevent_id = triggerevent.templateevent_id AND triggerevent.id = ".sqlf_tl_num($event_id);
$rs = query($sql);//            

//                                                                                              
 if (!event_dotrigger($event_id)) continue;

while (list($key,$val) = each($rs["arr"])) {

//                                       
 reset($values);
while (list($k, $keys) = each($values)) {

$props = get_reaction_props($val["id"],$val["workflowlink_id"], $keys);
$uids = get_reactionprop_userids($val["id"], $val["workflowlink_id"]);

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "do reaction: ".$val["keyword"]." id(".$val["id"].") workflowlink_id(".$val["workflowlink_id"].")<br>props:"; var_dump($props); echo "<br>uids:"; var_dump($uids); echo "<br><br>"; }

$recfunc = ($W_REACTION[$val["keyword"]]["reactionfunc"])?$W_REACTION[$val["keyword"]]["reactionfunc"]:$val["keyword"];
if (!$recfunc) halt(7, "trigger_event: could not find function for reaction '".$val["keyword"]."'.");

//                                           
 $sql = "SELECT id,keyword FROM triggerevent WHERE reaction_id = ".sqlf_tl_num($val["id"]);
$rs1 = query($sql);//            
 $revents = array();
$rdevents = array();
//                                                                   
 $j = 0;
while (list($rekey, $reval) = each($rs1["arr"])) {
if ( $j++ > 500 ) halt( 107, "trigger.func.php: stopped possible endless-loop at count ($j)" );
if (is_array($W_REACTION[$val["keyword"]]["triggered"]) && in_array($reval["keyword"],$W_REACTION[$val["keyword"]]["triggered"])) {
$rdevents[] = cmd_activate_event($reval["id"],"",$val["workflowlink_id"],1);
} else {
$revents[$reval["id"]] = $reval["keyword"];
}
}

//                                            
 $_handled = $handled;
$recval = $recfunc($val["keyword"], $props, $val["id"], $_handled, $uids);
$handled = $handled || $_handled;

reset($rdevents);
while (list($k, $v) = each($rdevents)) {
cmd_delete_event($v);
}

reset($revents);
while (list($k, $v) = each($revents)) {
cmd_activate_event($k,$recval,$val["workflowlink_id"],1);
}
}
}
}

return $handled;
}

//                                   
function get_wtype_info($field) {
global $W_TYPE;

$type = array($field=>true);

$type += get_wtype_alias($field, true);
reset ($type);
$info = array();

while (list($key,$val) = each($type)) {
$info = array_merge($W_TYPE[$key],$info);
}

return $info;
}

//                                                                                                    
//                                      
function get_wtype_alias($field, $list=false, $_list = array()) {
global $W_TYPE;

reset($W_TYPE);

$type = ($list)?$_list:"";

while (list($key,$val) = each($W_TYPE)) {
if (is_array($val["alias"]) && in_array($field, $val["alias"])) {
if ($list) {
$type[$key] = true;
$type = get_wtype_alias($key,true,$type);
} else {
$type = $key;
}
}
}

return $type;
}

/**
 *                    
 * 
 *                                                           
 *                                                                    
 *                
 **/
function get_wtype_accepts( $wtype, $wtypeInfo, $outputType, $outputTypeInfo=FALSE )
{
if ( $wtype == $outputType ) return TRUE;
global $DEBUG;

$wAliases = array_keys(get_wtype_alias( $wtype, true ));
$wAliasesInfo[$wtype] = $wtypeInfo;
foreach ( $wAliases as $wAlias )
$wAliasesInfo[$wAlias] = get_wtype_info( $wAlias );

$accepts = array();
foreach ( $wAliasesInfo as $wAlias=>$wAliasInfo ) {
if ( !is_array( $wAliasInfo["accept"] ) ) {
$aliasAccepts = array($wAlias);
}
else {
$aliasAccepts = $wAliasInfo["accept"];
$aliasAccepts[] = $wAlias;
}
$accepts = array_merge( $accepts, $aliasAccepts );
}
if ( $DEBUG["workflow"] && $DEBUG["echo"] )
{
echo "$wtype accepts: ";
echo implode( ", ", $accepts );
echo "<br />";
}

if ( in_array($outputType, $accepts) ) return TRUE;
if ( $outputTypeInfo === FALSE )
$outputTypeInfo = get_wtype_info($outputType);
if ( in_array($outputTypeInfo["type"], $accepts) ) return TRUE;

$aliases = array_keys(get_wtype_alias( $outputType, true ));
if ( $DEBUG["workflow"] && $DEBUG["echo"] )
{
echo "$outputType provides: ".implode( ", ", $aliases )."<br />";
}
foreach ( $aliases as $alias )
{
if ( in_array($alias, $accepts) ) return TRUE;
}
return FALSE; 
}


//                                                    
function complete_event_vals($event, $val) {
global $W_EVENT;

$missing = array();
if (is_array($W_EVENT[$event]["input"])) {
reset($W_EVENT[$event]["input"]);
while (list($k,$f) = each($W_EVENT[$event]["input"])) {
if (!isset($val[$f])) $missing[] = $f;
}
} else halt(7,"complete_event_vals: input of '$event' is not an array.");

if (count($missing)) {
reset($missing);

if (!$cfunc = $W_EVENT[$event]["expandobjects"]) {
warning(20, "complete_event_vals: could not complete event ($event): no completion function.");
return false;
}

//                                                              
 $input = array();
$rs = $cfunc($event, $val, $missing[0]);
if (is_array($rs)) {
reset($rs);
while (list($k, $v) = each($rs)) {
if (isset($v[$missing[0]])) {
$r = complete_event_vals($event, $v);
if (is_array($r)) {
reset($r);
while (list($k1, $v1) = each($r)) {
$input[] = $v1;
}
}
}
}
}
} else $input = array($val);

return $input;
}

//                             
function expand_event_vals($event, $val) {
global $W_EVENT;
$efunc = ($W_EVENT[$event]["expandinput"])?$W_EVENT[$event]["expandinput"]:"";
$vals = ($efunc)?$efunc($event,$val):$val;
return $vals;
}

//                                                                
function get_event_trigger($id, $workflowlink_id, $trigger = Array()) {
//                                                                                            

$sql = "SELECT keyword, value, info, mapkey FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($id)." AND workflowlink_id IN (0, ".sqlf_tl_num($workflowlink_id).") ORDER BY workflowlink_id";
$rs = query($sql);//            
 $keys = array();
if (!is_array($trigger)) $trigger = array();
while (list($k, $v) = each($rs["arr"])) {
if (!isset($trigger[$v["keyword"]]) || ($v["value"] && $v["info"])) {
//                                                                                            
 $keys[$v["keyword"]]["val"] = $v["value"];
$keys[$v["keyword"]]["info"] = $v["info"];
} else if (is_array($trigger[$v["keyword"]])) {
$keys[$v["keyword"]]["val"] = $trigger[$v["keyword"]]["val"];
$keys[$v["keyword"]]["info"] = $trigger[$v["keyword"]]["info"];
} else {
$keys[$v["keyword"]]["val"] = $trigger[$v["keyword"]];
$keys[$v["keyword"]]["info"] = $v["info"];
}
///                                         
 }
reset($trigger);
while (list($key, $v) = each($trigger)) {
if (isset($keys[$key])) continue;
if (is_array($v)) {
$keys[$key]["val"] = $v["val"];
$keys[$key]["info"] = $v["info"];
} else {
$keys[$key]["val"] = $v;
$keys[$key]["info"] = "";
}
}
return $keys;
}

//                                             
function get_reaction_props($reaction_id, $workflowlink_id, $val = array()) {
//                                                                
 $sql = "SELECT keyword, value, mapkey, workflowlink_id, reactionprop_id FROM reactionprop ".
"LEFT JOIN reactionpropeditable ".
"ON reactionprop_id=reactionprop.id ".
"WHERE reaction_id = ".sqlf_tl_num($reaction_id)." ".
"AND (workflowlink_id=0 ".
"OR workflowlink_id=".sqlf_tl_num($workflowlink_id).") ".
"ORDER BY workflowlink_id";
$rs = query($sql);//            
 $keys = array();
$editable = array();
while (list($key,$v) = each($rs["arr"])) {
if ( $v["workflowlink_id"] == 0 && $v["reactionprop_id"] )
$editable[$v["keyword"]] = TRUE;
else if ( $v["workflowlink_id"] > 0 && !$editable[$v["keyword"]] )
continue;
if ($v["mapkey"]) {
$keys[$v["keyword"]] = $val[$v["mapkey"]];
unset($val[$v["mapkey"]]);
unset($val[$v["keyword"]]);
} else {
$keys[$v["keyword"]] = $v["value"];
unset($val[$v["keyword"]]);
}
}
reset($val);
while (list($k,$v) = each($val)) {
if (!isset($key[$k])) $keys[$k] = $v;
}

return $keys;
}

function get_eventprop_userids($event_id, $workflowlink_id) {
$sql = "SELECT eventprop.keyword, workflow.editor AS wfeditor, workflowlink.editor AS wflinkeditor, MAX(eventprop.workflowlink_id) AS wfid 
  FROM triggerevent, workflow, eventprop LEFT JOIN workflowlink ON eventprop.workflowlink_id = workflowlink.id AND workflowlink.id = ".sqlf_tl_num($workflowlink_id)." 
  WHERE eventprop.triggerevent_id = triggerevent.id AND triggerevent.workflow_id = workflow.id AND triggerevent.id = ".sqlf_tl_num($event_id)." GROUP BY eventprop.keyword";
$rs = query($sql);//            
 $res = array();
while (list($key, $val) = each($rs["arr"])) {
$res[$val["keyword"]] = ($val["wfid"])?$val["wflinkeditor"]:$val["wfeditor"];
}
return $res;
}

function get_reactionprop_userids($reaction_id, $workflowlink_id) {
$sql = "SELECT reactionprop.keyword, reactionprop.mapkey, workflow.editor AS wfeditor, workflowlink.editor AS wflinkeditor, reactionprop.workflowlink_id AS wfid 
  FROM reaction, workflow, reactionprop LEFT JOIN workflowlink ON workflowlink.id = reactionprop.workflowlink_id AND workflowlink.id = ".sqlf_tl_num($workflowlink_id)." 
  WHERE reaction.id = reactionprop.reaction_id AND reaction.id = ".sqlf_tl_num($reaction_id)." AND workflow.id = reaction.workflow_id";
$rs = query($sql);//            
 $res = array();
while (list($key, $val) = each($rs["arr"])) {
if (!$val["mapkey"])
$res[$val["keyword"]] = ($val["wfid"])?$val["wflinkeditor"]:$val["wfeditor"];
}
return $res;
}

//                                                                   
//                     
//                                                          
//                                                              
//                                                                         
//                                                                            
//                                                                                                      
//                                                                          
//                                                                                                                                        
//                                                                                    
function trigger_match($input, $trigger) {
global $DEBUG;

$matched = array("input"=>$input, "trigger"=>array());

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "trigger_match:<br>"; var_dump($input); echo "<br>---<br>"; var_dump($trigger); echo "<br><br>"; }

while (list($k,$val) = each($trigger)) {
$value = $val["value"];
$info = $val["info"];
$key = $val["keyword"];

$cmd = ($p = strpos($info, ":"))?substr($info,0,$p):$info;
if($DEBUG["workflow"]) {
echo "cmd: $cmd <br>\n";
echo "input-key: ".$input[$key]."<br>\n";
}
//                                             
 if (!isset($input[$key])) continue;

if ($cmd == "match") {
if ($input[$key] != $value) return false;
} else if ($cmd == "nomatch") {
if ($input[$key] == $value) return false;
} else if ($cmd == "contain") {
if (is_false(strpos($input[$key], $value))) return false;
} else if ($cmd == "tree") {
$part = explode(":",$info);
$id = $input[$key];
$type = (is_numeric($part[1]))?$part[1]:$input[$part[1]];
$rec = ($part[2] == "recursive");
if (!strpos($value, ":") && is_numeric($type)) $value = $type.":".$value;

if (!$rec) {
if ($value != $type.":".$id) return false;
} else {
$root_type = substr($value,0,strpos($value,":"));
$root_id = substr($value,strpos($value,":")+1);
if ($root_type.":".$root_id != $type.":".$id) {
$sub = tree_get_parents($type, $id, 0, "", array("parent","parentfkt"), "", $root_type, $root_id);
if (!is_array($sub)) return false;
}
}

} else if ($cmd == "time") {
if (!($input["lasttime"] < $value && $value <= $input["time"])) return false;
} else if ($cmd == "period") {
$part = explode(":",$info);
$repeat = ($part[1] == "repeat");
if($DEBUG["workflow"]) {
echo "checking period: last:".$input["lasttime"]."; input:".$input[$key]."; value:$value; time:".$input["time"]." repeat: ".$repeat;
}
if (!(($input["lasttime"] - $input[$key] < $value || $repeat) && $value <= $input["time"] - $input[$key])) return false;

} else if($cmd == "global") {
//                     
 } else {
$matched["trigger"][$key] = array("value"=>$value,"info"=>$info);
}

}

if ($DEBUG["echo"] && $DEBUG["workflow"]) { echo "matched:<br>"; var_dump($matched); echo "<br><br>"; }

return $matched;
}

//                               
function match_events($event, $input, $reaction_id = 0) {
global $W_EVENT;
$sql = "SELECT id FROM triggerevent WHERE keyword = \"".sqlslashes($event)."\" AND templateevent_id != 0 AND active != 0";
if ($reaction_id != -1) $sql .= " AND reaction_id = ".sqlf_tl_num($reaction_id);
$rs = query($sql);//            

$events = array();
while (list($key,$val) = each($rs["arr"])) {
$event_id = $val["id"];
$sql = "SELECT keyword, value, info FROM eventprop WHERE triggerevent_id = ".sqlf_tl_num($event_id);
$keys = query($sql);//            
 $trigger = $keys["arr"];

$matched = trigger_match($input, $trigger);

if (!is_array($matched)) continue;

$trigger = $matched["trigger"];
$input = $matched["input"];

$values = (($triggerfunc = $W_EVENT[$event]["triggerfunc"]) && count($trigger))?$triggerfunc($event, $input, $trigger):$input;

if (is_array($values)) $events[$event_id] = $values;
}
return $events;
}

//                                                                                          
function event_dotrigger($event_id) {
$sql = "SELECT active,reaction_id,workflowlink_id FROM triggerevent WHERE id = ".sqlf_tl_num($event_id);
$rs = query($sql);//            
 if (!$rs["num"]) return false;
$active = $rs["arr"][0]["active"];
$reaction_id = $rs["arr"][0]["reaction_id"];
$link_id = $rs["arr"][0]["workflowlink_id"];
if (!$active) return false;
if ($active == 1) {
cmd_delete_event($event_id);
if ($reaction_id > 0) {
//                                    
 $sql = "SELECT id FROM triggerevent WHERE reaction_id = ".sqlf_tl_num($reaction_id)." AND workflowlink_id = ".sqlf_tl_num($link_id);
$rs = query($sql);//            
 foreach ($rs["arr"] as $val) {
//                                          
 cmd_delete_event($val["id"]);
}
}
} else if ($active > 1) {
$sql = "UPDATE triggerevent SET active = active - 1 WHERE id = ".sqlf_tl_num($event_id);
query($sql);//            
 }
return true;
}

//                           
function set_eventstate($id, $state) {
$sql = "UPDATE triggerevent SET active = ".sqlf_tl_num($state)." WHERE id = ".sqlf_tl_num($id);
query($sql);//            
}

function check_workflowlink($id, $trigger) {
return true;
}

?>
