<?

class GUIStreamObject extends GUIObject {

var $layer_left;
var $layer_top;
var $layer_width;
var $d_messageTags = array();
var $d_addHtml = "";

function GUIStreamObject() {
parent::GUIObject("stream");
$this->layer_left = 250;
$this->layer_top = 3;
$this->layer_width = 150;
}

//                                                                                    
 function getPassiveFooter(&$main)
{
global $FEATURE;
///                                              /        
 //                            
 $streamFrame = "top.main.ass";

//                     
 $infos = $this->getStaticInfos(false);
$dyn = $this->getDynamicInfos();

$footer .= "
<script type=\"text/javascript\">
if (top.main && $streamFrame) {
	if ($streamFrame.write_dynamic_status) {\n";

//                           
 reset($infos);
while (list($func, $info) = each($infos)) {
$footer .= "$streamFrame.write_status('$func', '".cleannl2bnl(addslashes($this->_buildStatus($info)))."');\n";
}

//                            
 //                                                                                
 if ($main->getGUIName() == "main") {
$dynStatus = $this->_buildStatus($dyn,true);
$footer .= "$streamFrame.write_dynamic_status('".cleannl2bnl(addslashes($dynStatus))."');\n";
}

if ( $FEATURE["error_autopopup"] && $dynStatus )
$autoPopupJs = "$streamFrame.streamPopup.focus();";

$footer .= "
	}
	if ( $streamFrame.streamPopup )
		if(  !$streamFrame.streamPopup.closed )
		{
			$streamFrame.streamPopup.document.location.href = $streamFrame.streamPopup.document.location.href;
			$autoPopupJs 
		}
}
</script>\n";

return $footer;

}

function getPassiveHTML(&$main) {

}

function getHeader() {
$header = parent::getHeader();
$this->includeJS("layer");		
$header .= "
<script type=\"text/javascript\">
	var streamPopup;
	function open_status_window( url ) {
		if ( streamPopup ) 
			if ( !streamPopup.closed )
			{
				streamPopup.document.location.href = url;
				streamPopup.focus();
				return;
			}
		streamPopup = window.open( url, 'status_window', 'dependent=yes,status=no,width=540,height=400,resizable=yes,scrollbars=yes' );
	}
	
	function write_status(status, value) {
		l = get_layer(status);
		write_layer(l, value);
		show_layer(l);
	}
";

/*                            
  //                                    
                               
                          
               
                                         
                                                                                                           
   
  */

$header .= "</script>\n";

return $header;

}

function getHTML() {
$html = parent::getHTML();

///                                                                   
 
$infos = $this->getStaticInfos(true);

$layer_left = $this->layer_left;
$layer_width = $this->layer_width;
$layer_top = $this->layer_top;
reset($infos);
while (list($func, $info) = each($infos)) {
$status = $this->_buildStatus($info);
$html .= "<div id=\"$func\" style=\"position:absolute;left:".$layer_left."px;top:".$layer_top."px;width:".$layer_width."px;visibility:visible;\">$status</div>";
$layer_left += ($layer_width + 20);
}
$html .= "<div id=\"dynamicStatus\" style=\"position:absolute;left:".$layer_left."px;top:".$layer_top."px;width:".$layer_width."px;visibility:visible;\"></div>";
$html .= $this->d_addHtml;
return $html;
}

function reloadStream() {

}

function useEaster($img_id) {
global $JS_ONCLICK;
$this->includeJS("stream");
$JS_ONCLICK = "check_click(event, get_element(\"streamdiv\"))\n";
$this->d_addHtml .= "<div id=\"streamdiv\" style=\"visibility: hidden\"></div>";
}

function getStaticInfos($force = true) {
global $LAST_STATUS_CHECK, $UPDATE_STATUS, $TIME, $STATUS_FUNC;
$rs = array();

mysession_var_reg("LAST_STATUS_CHECK");
if ($LAST_STATUS_CHECK + $UPDATE_STATUS > $TIME && !$force) return $rs;

$LAST_STATUS_CHECK = $TIME;

node_include("STATUS");
if (is_array($STATUS_FUNC)) {
reset($STATUS_FUNC);
while (list($k, $func) = each ($STATUS_FUNC)) {
if (function_exists($func)) {
$rs[$func] = $func();
}
}
}

return $rs;
}

function setLayerLeft($val) {
$this->layer_left = $val;
}

function setLayerWidth($val) {
$this->layer_width = $val;
}

function setLayerTop($val) {
$this->layer_top = $val;
}


function _buildStatus($infos, $isArray = false) {
global $STAG_PREFIX;

if (!$isArray) $infos = array($infos);
if ( !count($infos) )
return "";

//                              
 sort($infos);
$rep = false;
//                                                                                                                                                  /                       
 $ret = "<table cellpadding=0 cellspacing=0 border=0><tr><td valign=middle>";
foreach ($infos as $obj) {

$info = $this->explodeInfoObject( $obj );
if (!$info["text"]) continue;
if ($rep) $ret .= "</td><td>".img("",0,0,0,10,1).img("$STAG_PREFIX?do=11&module=system&img=menu_delimeter.png").img("",0,0,0,10,1)."</td><td valign=middle>";
$rep = true;

$link = $info["link"];
$target = ($info["target"])?$info["target"]:"list";
$onclick = ($info["onclick"])?" onclick=\"".$info["onclick"]."\"":"";
if ($info["icon"]) {
if ($link) $ret .= "<a href=\"#\" $onclick>";
$ret .= img($info["icon"], 0, $info["icon_title"]);
if ($link) $ret .= "</a>";
$ret .= "</td><td nowrap valign=middle>".img("",0,0,0,7,1);
}
if ($link) $ret .= "<a href=\"".$info["link"]."\" $onclick target=$target>";
$ret .= $info["text"];
if ($link) $ret .= "</a>";
}

$ret .= "</td></tr></table>";

return $ret;
}

}

?>
