<?php

/**
 * 
 *
 *                                                                            
 *                                     
 **/

class Info extends BaseObject
{

function Info( ) {
if ( $this->_static_(TRUE) ) return;
}

/**
  *                      
  * 
  *                                                                     
  **/
function getInfo()	{}


/**
  *                              
  * 
  *                                                                     
  *                                                          
  **/
function getExplodedInfo() { return $this->getInfo(); }

function getWidth() { return 150; }
function hasDelimiter() { return TRUE; }

function getJavascript(&$guiObject) {}

function getPassiveHeader(&$guiObject) {}
}

class StreamInfo extends Info
{
function StreamInfo($itemOrder = 0)
{
if ( $this->_static_() ) return;
parent::Info( );
$stream =& GUIFactory::getGUI( "stream" );
if ( !is_a( $stream, "nodeexception" ) )
$stream->addInfoObject( $this, $itemOrder );
}
}

class StatusInfo extends Info
{
function StatusInfo()
{
parent::Info( );
}
}

class DefaultStreamInfo extends StreamInfo
{
var $d_messages = array();
var $d_sessionVar = "";
var $d_sessionName = "";
var $d_i18n = "";
var $d_icon = "";

function DefaultStreamInfo( $i18n, $icon,$itemOrder = 0 )
{
if ( $this->_static_() )return;

$this->d_i18n = $i18n;
$this->d_icon = $icon;
$this->d_sessionName = get_class($this);
$name = "si_$this->d_sessionName";
$this->d_sessionVar = $name;
mysession_var_reg($name);
global $$name;
$$name = array();
parent::StreamInfo( $itemOrder );
}

//                                                           
 function addMessage( $type, $icon, $text, $longText=false )
{
global $$this->d_sessionVar;
node_include("img");
if ( $longText === false ) $longText = $text;
$info = array("type"=>$type, "icon"=>($icon!==NULL)?img($icon):NULL, "iconsrc"=>$icon,
"text"=>$text, "longtext"=>$longText);
$this->d_messages[] = $info;
${$this->d_sessionVar}[] = $info;
}

function getSessionName()
{
return $this->d_sessionName;
}

function getMessagesForSession( $className )
{
$name = "si_$className";
global $$name;
return $$name;
}

//                                                     
 /**
  *                             
  *
  *                          
  *  
  *         
  **/
function getInfo()
{
global $STAG;
if ( count($this->d_messages) > 0 )
{
$sName = $this->d_sessionName;
return array( "link"=>"$STAG&do=950&sname=$sName", "text"=>i18n($this->d_i18n, 0, count($this->d_messages)),
"icon" => $this->d_icon,
"onclick" => "top.logo.open_status_window('$STAG&do=950&sname=$sName'); return false;",
"target" => "streaminfo"
);
}
}

function getExplodedInfo()
{
$ret = $this->getInfo();
if ( is_array($ret) )
$ret["details"] = $this->d_messages;
return $ret;
}
}
class StatusMessage extends StatusInfo
{
var $d_message = "";

function StatusMessage()
{
if ( $this->_static_() ) return;
parent::StatusInfo();
mysession_var_reg( "STATUS_MESSAGE" );
}

function hasDelimiter() { 
global $FEATURE, $MYPROGRESS; 
return !($FEATURE["progressbar"] && $MYPROGRESS != "no");
}

function setMessage( $msg )
{
$this->d_message = $msg;
global $STATUS_MESSAGE;
$main =& GUIFactory::getMainGUI();
$STATUS_MESSAGE = array( "gui"=>$main->getGUIName(), "message"=>$msg );
}

function getInfo() {
global $STATUS_MESSAGE;
$main =& GUIFactory::getMainGUI();
if ( !$this->d_message && is_array( $STATUS_MESSAGE ) )
{
if ( $main->getGUIName() != $STATUS_MESSAGE["gui"] )
$this->d_message = $STATUS_MESSAGE["message"];
else
$STATUS_MESSAGE = NULL;
}

$rs = array();
$rs["text"] = $this->d_message;
return $rs;
}

function getExplodedInfo()
{
$ret = $this->getInfo();
if ( is_array($ret) )
$ret["details"] = array( array( "text"=>$this->d_message ) );
return $ret;
}
}


class ProgressStatusInfo extends StatusInfo
{
function ProgressStatusInfo() {
parent::StatusInfo();
}

function buildProgressLink( $url, $target = "" )
{
global $FEATURE, $MYPROGRESS;
$frameList = array( "tree", "list" );
$ispoup = in_array( GUIFactory::getMainGUIName(), array( 
"popup", "dialog" )  );
$ispopup |= ($target && !in_array( $target, $frameList ));
if ( $FEATURE["progressbar"] && !$ispopup && $MYPROGRESS != "no" )
{
return "if(self.progress){progress(top.menu,document,'".addslashes($url)."');}else{document.location.href='".addslashes($url)."';}";
}
else
return "document.location.href='".addslashes($url)."'";
}

function getProgressStarter()
{
global $FEATURE, $MYPROGRESS;
$ispoup = in_array( GUIFactory::getMainGUIName(), array( 
"popup", "dialog" )  );
if ( $FEATURE["progressbar"] && !$ispopup && $MYPROGRESS != "no" )
return "top.menu.startProgress();";
}

function getInfo() {
global $ICO_TIMECLOCK;
$rs = array();
$rs["text"] = "<div id=\"progress\"></div>";
$rs["divstyle"] = "position: absolute; top: 5px; right: 5px;";
return $rs;
}

function getWidth()
{
return 0;
}

function getPassiveHeader(&$guiObject)
{
//                                             
 {
$prefix = $guiObject->getFramePrefix();
global $JS_ONLOAD;
$JS_ONLOAD .= "try { if ($prefix) $prefix.stopProgress(); } catch (e) {}\n";
}
}

function getJavascript(&$guiObject) {
global $MYPROGRESS, $STAG_PREFIX;
if ( !$MYPROGRESS ) $MYPROGRESS = "loading.gif";
///                                         
 $guiObject->includeJS( "layer" );
if ( $MYPROGRESS != "no" )
$image = addslashes(img("$STAG_PREFIX?do=11&module=system&img=".$MYPROGRESS));
else
$image = "";

$js = "
var progressCount = 0;		
function startProgress ( doc, url ) {
	var l;
	progressCount++;
	if ( progressCount == 1 )
	{
		l = get_layer('progress');
		write_layer( l, '".$image."' );
	}
	if ( doc && url )
		doc.location.href = url;
}

function stopProgress () {
	var l;
	if ( progressCount > 0 )
		progressCount--;
	l = get_layer('progress');
	write_layer( l, '');
}
		";
return $js;
}
}



class AlertStreamInfo extends DefaultStreamInfo
{
function AlertStreamInfo()
{
global $ICO_ALERT_ANI;
parent::DefaultStreamInfo("{0} Alert(s)", $ICO_ALERT_ANI, 1);
}
}

class DebugStreamInfo extends DefaultStreamInfo
{
function DebugStreamInfo()
{
global $ICO_BUG;
parent::DefaultStreamInfo("{0} debugging(s)", $ICO_BUG, 99);
}

function getInfo() {
global $DEBUG, $STREAMINFO_DEBUG, $USER_ID, $FEATURE;
if (($STREAMINFO_DEBUG["debug"] && ($DEBUG["echo"] || $FEATURE["user_debugstream"])) || $USER_ID == 1) {
return parent::getInfo();
}
}
}

class InfoStreamInfo extends DefaultStreamInfo
{
function InfoStreamInfo()
{
global $ICO_INFO;
parent::DefaultStreamInfo("{0} Info(s)", $ICO_INFO, 2);
}
}

?>
