<?

class CNPageLanguageObject extends CNObject {
var $d_pageLangId;
var $d_code;
var $d_name;

/**
  *                                             
  * 
  *                     
  *         
  **/
function CNPageLanguageObject( $id = 0 )
{
$this->setID($id);
$this->setViewLinkParams("do=14202&cmd=edit&id=" . $this->getId());
}

function getTType()
{
global $T_PAGELANGUAGE;
return $T_PAGELANGUAGE;
}

function getParentTType() {
return array(T_PAGELANGUAGE);
}

function _checkPermission($parentObjectType, $parentObjectId) {
global $USER_ID;
return perm($USER_ID, $parentObjectType, $parentObjectId, 0);
}

function getIcon() {
return get_pageicon(1,$this->getFieldValue("code"));
}

function _setID($id) {
$this->d_pageLangId = $id;
}

function getID() {
return (int) $this->d_pageLangId;
}

function initFromKey($code = "") {
$dbLand = sqlslashes( $code );
$sql = "SELECT id, code, name FROM contentgroup WHERE code = '".sqlf_escaped($dbLand)."'";
$rs = query($sql);//            
 if ($rs["num"] != 1) return false;

$this->setID($rs["arr"][0]["id"]);
$this->setFieldValue("code", $rs['arr'][0]['code']);
$this->setFieldValue("name", $rs['arr'][0]['name']);
return true;
}

function getValueFields() {
return array( "name"=>"text", "code"=>"text");
}

function &getFormObject() { return new CNPageLanguageFormObject($this); }

function checkErrors() {

$name = sqlslashes($this->getFieldValue("name"));
$code = sqlslashes($this->getFieldValue("code"));

$sql = "SELECT id  FROM contentgroup WHERE name LIKE '".sqlf_escaped($name)."' AND id != ".sqlf_tl_num($this->getID());
$rs = query($sql);//            
 if ($rs["num"] > 0) {
$this->_setError(new NodeException(i18n("This name is already in use in this branch.")), "name");
return false;
}

$sql = "SELECT id  FROM contentgroup WHERE code LIKE '".sqlf_escaped($code)."' AND id != ".sqlf_tl_num($this->getID());
$rs = query($sql);//            
 if ($rs["num"] > 0) {
$this->_setError(new NodeException(i18n("This code is already in use in this branch.")), "code");
return false;
}
return true;
}

function _getNodeTable() { return "contentgroup"; }

function _initDefaults() {
return true;
}

function canDelete() {
//                                            
 $sql = "SELECT count(*) c FROM page WHERE contentgroup_id = ".sqlf_tl_num($this->getID());
$rs = query($sql);
if ($rs["arr"][0]["c"] != 0) {
$this->_setError(new NodeException(i18n("There are Pages using this Language. Please change there Language first.")));
return false;
} else {
return true;
}
}

function _deleteObject() {
$err = false;
if (!$err) {
$sql = "DELETE FROM node_contentgroup WHERE contentgroup_id = ".sqlf_tl_num($this->getID());
query($sql);//            
 $sql = "DELETE FROM contentgroup WHERE id = ".sqlf_tl_num($this->getID());
query($sql);//            
 }
return !$err;
}

function& _getChild( $key )
{
return NULL;  
}

function &getChilds()
{
return false;	
}

function getPropertyNames() {
return array_merge(parent::getPropertyNames(), array("name"=>i18n("Name"), "code"=>i18n("code")) );
}

function& getProperty( $key )
{
switch ( $key )
{
case "id":
return new IntObject($this->getID());
case "code":
return new StringObject($this->getFieldValue("code"));
case "name":
return new StringObject($this->getFieldValue("name"));
default:
return parent::getProperty($key);
}		
}

function onUpdateObject() {
global $T_PAGELANGUAGE;

if ($this->d_objectFieldValues == $this->d_objectLoadedFieldValues) {
return;
}

node_func( "triggerEvent" );
node_include("dirt");

//        
 logcmd(W_EDIT, $T_PAGELANGUAGE, $this->getID());
//              
 triggerEvent( $T_PAGELANGUAGE, $this->getID(), EVENT_UPDATE, new EventObject() );
}

function onInsertObject() {
global $T_PAGELANGUAGE;

node_func( "triggerEvent" );
node_include("dirt");

//        
 logcmd(W_CREATE, $T_PAGELANGUAGE, $this->getID());
//              
 triggerEvent( $T_PAGELANGUAGE, $this->getID(), EVENT_CREATE, new EventObject() );
}

function onDeleteObject() {
global $T_PAGELANGUAGE;
node_func( "triggerEvent" );
node_include("dirt");

//        
 logcmd(W_DEL, $T_PAGELANGUAGE, $this->getID());
//              
 triggerEvent( $T_PAGELANGUAGE, $this->getID(), EVENT_DELETE, new EventObject() );
}

function _checkSearchTerm($searchTerm) {
if (! $searchTerm) {
return true;
}
$name = $this->getFieldValue("name");
if (strpos(strtolower($name), strtolower($searchTerm)) !== FALSE) {
return true;
}
return false;
}
}

class CNPageLanguageFormObject extends NodeFormObject {

function getValueFields() {
return array("name"=>"text", "code"=>"text", "icon"=>false);
}

function getFieldLabels() {
return array( "name" => i18n("Name"), "code" => i18n("code"), "icon"=>i18n("Icon"));
}

function isEditableField($field) {
return true;
}

function isOptionalField($field) {
return false;
}

function &getFormComponent($field) {
global $FILEPATH;
switch ($field) {
case "icon":
node_class("filecomponent");
$comp = new FileComponent(i18n("Icon"));
//           
 //                                              /         /                                        
 break;
case "code":
node_class("textcomponent");
$comp = new TextComponent(i18n("Code"), true, $this->getFieldValue("code"));
break;
default:
$comp = false;
}
return $comp;
}

function storeFormComponent($field, &$comp) {
global $FILEPATH;
/*                          */
switch ($field) {
case "icon":
if ($comp->isUploaded()) {
//                                                                  
 $file =& $comp->getResultObject();
} else if ( !$this->isNew() ) {
$file = new FileObject("$FILEPATH/languages/".$this->getStoredFieldValue("code").".gif");

if ( !$file->exists() )
$file = false;
} else
$file = false;

if ( $file && !$file->isEmpty()) {
$file->storeTo("$FILEPATH/languages/".$this->getFieldValue("code").".gif");
node_class("img_resize");
$resizer = new img_resize("$FILEPATH/languages/".$this->getFieldValue("code").".gif");
$resizer->clearCache();
}
break;
case "code":
if ($this->getFieldValue("code") == $comp->getText()) break;
///                                                    
 ///                                           
 $file = new FileObject("$FILEPATH/languages/".$this->getFieldValue("code").".gif");
$file->moveTo("$FILEPATH/languages/".$comp->getText().".gif");
$this->setFieldValue("code",$comp->getText());
break;
}
}
}

?>
