<?

//                                                         
function objprop_check_nodelimit( $objprop_id, $node_id ) {
//                                                                       
 if( !$objprop_id ) return true;

$sql = "SELECT node_id FROM objprop_node WHERE objprop_id = '".sqlf_escaped($objprop_id)."'";
$rs = query( $sql );//            
 if( $rs['num'] < 1 ) return true;
foreach( $rs['arr'] as $row ) {
if( $row['node_id'] == $node_id ) return true;
}
return false;
}

//                                                                              
function objprop_required ($page_id)
{

global $DEBUG, $T_TEMPLATE, $T_FOLDER, $T_PAGE;

$sql = "SELECT folder.node_id FROM page INNER JOIN folder ON page.folder_id = folder.id WHERE page.id = '".sqlf_escaped($page_id)."'";
$rs = query( $sql );//            
 $node_id = $rs['arr'][0]['node_id'];

$required = Array();

//                                                             
 $sql = "SELECT objtag.id, objtag.name, objtag.construct_id, objprop.id AS objprop_id FROM objtag
        INNER JOIN page ON objtag.obj_id = page.folder_id AND page.id = ".sqlf_tl_num($page_id)."
	LEFT JOIN objtag AS defobjtag ON defobjtag.name = objtag.name AND defobjtag.obj_id = 0 AND defobjtag.obj_type = objtag.obj_type 
        LEFT JOIN objprop ON objprop.objtag_id = defobjtag.id WHERE objtag.obj_type = ".sqlf_tl_num($T_FOLDER)." AND objtag.inpage = 1 AND objtag.required = 1
	AND page.id = ".sqlf_tl_num($page_id);
if ($DEBUG['objtag_required']) echo "get required tags from folder:<br>$sql<hr>";
$rs = query($sql);//            

if ($rs['num'] > 0)
{
foreach ( $rs['arr'] as $v )
{
if(objprop_check_nodelimit( $v['objprop_id'], $node_id ))
$required[$v['name']] = $v;
}
}

//                                                               
 $sql = "SELECT objtag.id, objtag.name, objtag.construct_id,objprop.id AS objprop_id FROM objtag
        INNER JOIN page ON objtag.obj_id = page.folder_id AND page.id = ".sqlf_tl_num($page_id)."
	LEFT JOIN objtag AS defobjtag ON defobjtag.name = objtag.name AND defobjtag.obj_id = 0 AND defobjtag.obj_type = objtag.obj_type
        LEFT JOIN objprop ON objprop.objtag_id = defobjtag.id WHERE objtag.obj_type = ".sqlf_tl_num($T_TEMPLATE)." AND objtag.inpage = 1 AND objtag.required = 1
	AND page.id = ".sqlf_tl_num($page_id);
if ($DEBUG['objtag_required']) echo "get required tags from template:<br>$sql<hr>";
$rs = query($sql);//            

if ($rs['num'] > 0)
{
foreach ( $rs['arr'] as $v )
{
if(objprop_check_nodelimit( $v['objprop_id'], $node_id ))
$required[$v['name']] = $v;
}
}

//                                     
 $sql = "SELECT objtag.id, objtag.name, objtag.construct_id,objprop.id AS objprop_id FROM objtag
LEFT JOIN objtag AS defobjtag ON defobjtag.name = objtag.name AND defobjtag.obj_id = 0 AND defobjtag.obj_type = objtag.obj_type
LEFT JOIN objprop ON objprop.objtag_id = defobjtag.id
WHERE objtag.obj_type = ".sqlf_tl_num($T_PAGE)." AND objtag.required = 1 AND objtag.obj_id = ".sqlf_tl_num($page_id);
if ($DEBUG['objtag_required']) echo "get required tags from page:<br>$sql<hr>";
$rs = query($sql);//            

if ($rs['num'] > 0) {
foreach ($rs['arr'] as $v ) {
if(objprop_check_nodelimit( $v['objprop_id'], $node_id ))
$required[$v['name']] = $v;
}
}

return $required;

}

function objprop_required_check($page_id) {

global $FEATURE, $DEBUG, $LANGUAGE, $T_PAGE;

if(!$page_id) return false;

$objprops = objprop_required ($page_id);
$_page_id = $page_id;

$error = Array();

#                                  
 ##                                                                       
 ##                                            /             
 $globals = array();
foreach ( $GLOBALS as $key => $value ) {
global $$key;
if( $key[0] == 'p' || $key[0] == 'f' || $key == 'onoff' ) {
$globals[$key] = $value;
$$key = NULL;
}
}

foreach ($objprops as $objprop) {

//                                  
 $sql = "SELECT part.id, part.type_id, part.partorder, part.keyword, part.info_int,
		part.info_text, part.required, type.name, dicuser.value
		FROM part
		LEFT JOIN type ON (part.type_id = type.id)
		LEFT JOIN dicuser ON (part.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE).")
		WHERE part.construct_id = ".sqlf_tl_num($objprop['construct_id'])." AND part.editable > 0  ORDER BY part.partorder";
$rs = query($sql);//            
 $parts = $rs["arr"];

$sql = "SELECT id,required,enabled FROM objtag WHERE name = '".sqlf_escaped($objprop['name'])."' AND obj_type = ".sqlf_tl_num($T_PAGE)." AND obj_id = ".sqlf_tl_num($_page_id);
$rs = query($sql);//            
 if( $rs['num'] > 0 && !$rs['arr'][0]['enabled'] && $rs['arr'][0]['required'] ) {
$error[$objprop['name']] = TRUE;
continue;
}



node_include('form_do');
if( count( $parts ) < 1 ) {
//                                                                        
 continue;
}
$tmp = part_genform ($parts);


if ($rs['num'] > 0) {
tag_loadform($rs['arr'][0]['id'], 'obj');
}

$hi = array();
while (list($key,$part) = each($tmp['parts'])) {
while (list($keyel,$partel) = each($part)) {
$hi[] = $partel;
}
}

unset($f);
$f = new htmlform ($hi, '__private__');
$f->issubmit = true;
$f->docheck = 1;

foreach ($tmp['vars'] as $var) {
global $$var, ${'f_'.$var};
${'f_'.$var} = $$var;
}

$f->check_elements($hi);
foreach ($f->check as $e=>$v) {
if ($v) {
$error[$objprop['name']] = $v;
}
}

foreach ($tmp['vars'] as $var) {
global $$var, ${'f_'.$var};
$$var = NULL;
${'f_'.$var} = NULL;
}


}
//                                 
 global $f_onoff; unset( $f_onoff );
foreach( $globals as $key => $value ) {
$GLOBALS[$key] = $value;
}

return $error;
}

?>
