<?          

function GetMailKapazitaet($client, $year, $month, $day, $logfile_name)
{
//                     
 
$body =	'<GetMailKapazitaet xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Tag xmlns="http://tempuri.org/Newsletter.xsd">' . $year . '-' . $month . '-' . $day . '</Tag>
	</request>
	</GetMailKapazitaet>';

$response = $client->call('GetMailKapazitaet', $body);

//                   

$fp = fopen( $logfile_name, "a" );	

if ($client->fault)
{
fwrite($fp, "<h2>Error:</h2><pre>" . print_r($response) . "</pre>");		
}
else 
{
//                 
 
$err = $client->getError();

if ($err) 
{
?>
			<script type="text/javascript">
		  	alert("Error: " + <?php echo $err; ?>");
			</script>			
			<?php
 } 
else 
{
//                   
 
$output = print_r($response, true);

fwrite($fp, $output);		
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Response:</h2><pre>" . htmlspecialchars($client->response, ENT_QUOTES) . "</pre>");
}
}	
fclose($fp);
return $response;
}

function AddNewsletter($client, $update, $body_html_replaced, $logfile_name)
{
//                     
 global $PDB, $AHSTID, $AHSTNAME;

if ( $PDB && $update ) {
$sql = "SELECT nl.id, ng.id, nl.name, sellanguage FROM newsletter_list nl, newsletter_group ng " . 
"WHERE ng.ngid = nl.id AND ng.newsletter_id = " . $update;
$rs = query( $sql, $PDB );
$sellang = $rs["arr"][0]["sellanguage"];
if ( !$sellang ) $sellang = "de";

//                 
 $ahst_id = $AHSTID;
$ahst_name = $AHSTNAME;
}


$body='<AddNewsletter xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Newsletter_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $update . '</Newsletter_ID>
	<Language xmlns="http://tempuri.org/Newsletter.xsd">' . $sellang . '</Language>
	<MailContent xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $body_html_replaced . ']]></MailContent>
	<Ahst_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $ahst_id . '</Ahst_ID>
	<NameDienststelle xmlns="http://tempuri.org/Newsletter.xsd">' . $ahst_name . '</NameDienststelle>
	</request>
	</AddNewsletter>';

$response = $client->call('AddNewsletter', $body);		

//                   

$fp = fopen($logfile_name, "a");	

if ($client->fault)
{
fwrite($fp, "<h2>Error:</h2><pre>" . print_r($response) . "</pre>");		
}
else 
{
//                 
 
$err = $client->getError();

if ($err) 
{
?>
			<script type="text/javascript">
		  	alert("Error: " + <?php echo $err; ?>");
			</script>			
			<?php
 } 
else 
{
//                   
 
$output = print_r($response, true);

fwrite($fp, $output);		
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Response:</h2><pre>" . htmlspecialchars($client->response, ENT_QUOTES) . "</pre>");
}
}	
fclose($fp);
return $response;
}

function AddAdressen($client, $update, $user_array, $logfile_name)
{
//                     

$body = '<AddAdressen xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Newsletter_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $update . '</Newsletter_ID>
	<Adressen xmlns="http://tempuri.org/Newsletter.xsd">';

for ($i = 0 ; $i < count($user_array) ; $i++)
{
if ( $user_array[$i]['userid'] )
{
if (!$user_array['var_field1']) $user_array['var_field1'] = 0;
if ($user_array['gender'] == '1') $gender = "";
elseif ( $user_array['gender'] == '2' ) $gender = "";
else $gender = "";

$body .= "<Adresse>" .
"<User_ID>" . $user_array[$i]['userid'] . "</User_ID>" . 
"<Anrede>" . $gender . "</Anrede>";
$body .= "<Titel><![CDATA[" . $user_array[$i]['title'] . "]]></Titel>" . 
"<Vorname><![CDATA[" . $user_array[$i]['firstname'] . "]]></Vorname>";
$body .= "<Nachname><![CDATA[" . $user_array[$i]['lastname'] . "]]></Nachname>" . 
"<EMail><![CDATA[" . $user_array[$i]['email'] . "]]></EMail>";
$body .= "<Firma><![CDATA[" . $user_array[$i]['company'] . "]]></Firma>";
$body .= "<AWIS_User_ID>" . $user_array[$i]['var_field1'] . "</AWIS_User_ID></Adresse>";
}
}	
$body .= '</Adressen>
     	</request>
    	</AddAdressen>';

$response = $client->call('AddAdressen', $body);		

//                   

$fp = fopen( $logfile_name, "a" );	

if ($client->fault)
{
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Error:</h2><pre>" . print_r($response, true) . "</pre>");		
}
else 
{
//                 
 
$err = $client->getError();

if ($err) 
{
?>
			<script type="text/javascript">
		  	alert("Error: " + <?php echo $err; ?>");
			</script>			
			<?php
 } 
else 
{
//                   
 
$output = print_r($response, true);

fwrite($fp, $output);		
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Response:</h2><pre>" . htmlspecialchars($client->response, ENT_QUOTES) . "</pre>");
}
}	
fclose($fp);
return $response;
}

function AddVersanddatum($client, $update, $year, $month, $day, $subject, $mailfrom, $mailfromname, $logfile_name)
{
//                     

$body = '<AddVersanddatum xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Newsletter_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $update . '</Newsletter_ID>
	<Versanddatum xmlns="http://tempuri.org/Newsletter.xsd">' . $year . '-' . $month . '-' . $day . '</Versanddatum>
	<MailSubject xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $subject . ']]></MailSubject>
	<MailFrom xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $mailfrom . ']]></MailFrom>
	<MailFromName xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $mailfromname . ']]></MailFromName>
	<Reservierung xmlns="http://tempuri.org/Newsletter.xsd">false</Reservierung>
	</request>
	</AddVersanddatum>';

$response = $client->call('AddVersanddatum', $body);		

//                   

$fp = fopen( $logfile_name, "a" );	

if ($client->fault)
{
fwrite($fp, "<h2>Error:</h2><pre>" . print_r($response) . "</pre>");		
}
else 
{
//                 
 
$err = $client->getError();

if ($err) 
{
?>
			<script type="text/javascript">
		  	alert("Error: " + <?php echo $err; ?>");
			</script>			
			<?php
 } 
else 
{
//                   
 
$output = print_r($response, true);

fwrite($fp, $output);		
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Response:</h2><pre>" . htmlspecialchars($client->response, ENT_QUOTES) . "</pre>");
}
}	
fclose($fp);
return $response;
}

function TestVersand($client, $update, $user_array, $subject, $mailfrom, $mailfromname, $logfile_name)
{
//                     

$body =	'<TestVersand xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Newsletter_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $update . '</Newsletter_ID>
	<Adressen xmlns="http://tempuri.org/Newsletter.xsd">';

for ($i = 0 ; $i < count($user_array) ; $i++)
{
if (  $user_array[$i]['var_field1'] == "" )  $user_array[$i]['var_field1'] = 0;
if ($user_array['gender'] == '1') $gender = "";
elseif ( $user_array['gender'] == '2' ) $gender = "";
else $gender = "";

$body .= "<Adresse>" . 
"<User_ID>" . $user_array[$i]['userid'] . "</User_ID>" . 
"<Anrede><![CDATA[" . $gender . "]]></Anrede>";
$body .= "<Titel><![CDATA[" . $user_array[$i]['title'] . "]]></Titel>" . 
"<Vorname><![CDATA[" . $user_array[$i]['firstname'] . "]]></Vorname>";
$body .= "<Nachname><![CDATA[" . $user_array[$i]['lastname'] . "]]></Nachname>" . 
"<EMail><![CDATA[" . $user_array[$i]['email'] . "]]></EMail>";
$body .= "<Firma><![CDATA[" . $user_array[$i]['company'] . "]]></Firma>";
$body .= "<AWIS_User_ID>" . $user_array[$i]['var_field1'] . "</AWIS_User_ID>" .
"</Adresse>";
}	
$body .= '</Adressen>
        <MailSubject xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $subject . ']]></MailSubject>
        <MailFrom xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $mailfrom . ']]></MailFrom>
	<MailFromName xmlns="http://tempuri.org/Newsletter.xsd"><![CDATA[' . $mailfromname . ']]></MailFromName>
	</request>
    	</TestVersand>';

$response = $client->call('TestVersand', $body);		

//                   

$fp = fopen( $logfile_name, "a" );	

if ($client->fault)
{
fwrite($fp, "<h2>Error:</h2><pre>" . print_r($response) . "</pre>");		
}
else 
{
//                 
 
$err = $client->getError();

if ($err) 
{
?>
			<script type="text/javascript">
		  	alert("Error: " + <?php echo $err; ?>");
			</script>			
			<?php
 } 
else 
{
//                   
 
$output = print_r($response, true);

fwrite($fp, $output);		
fwrite($fp, "<h2>Request:</h2><pre>" . htmlspecialchars($client->request, ENT_QUOTES) . "</pre>");
fwrite($fp, "<h2>Response:</h2><pre>" . htmlspecialchars($client->response, ENT_QUOTES) . "</pre>");
}
}	
fclose($fp);
return $response;
}

function GetVersandstatus($id)
{
global $NODEPATH, $MODULE, $NEWSLETTER_WEBSERVICE_WSDL;

require_once("$NODEPATH/modules/$MODULE/include/lib/nusoap.php");

$client = new soapclient($NEWSLETTER_WEBSERVICE_WSDL, true, '', '', '', '');
$client->soap_defencoding = 'UTF-8';
$err = $client->getError();
if ($err) 
{
?>
		<script type="text/javascript">
		 	alert("WEBSERVICE: Constructor Error!");
			</script>			
		<?php	
}

//                     
 
$body='<GetVersandstatus xmlns="Gritsoft.Portal.Service.Utils.Newsletter.NewsletterATO">
	<request>
	<Newsletter_ID xmlns="http://tempuri.org/Newsletter.xsd">' . $id . '</Newsletter_ID>
	</request>
	</GetVersandstatus>';

$response = $client->call('GetVersandstatus', $body);

//                  
 if ($client->fault) 
{
echo '<h2>Fault</h2><pre>';
print_r($result);
echo '</pre>';
} 
else 
{
//                 
 $err = $client->getError();
if ($err) {
//                  
 echo '<h2>Error</h2><pre>' . $err . '</pre>';
} 
else 
{
$array = array_values( $response );
return $array;
}
}
}

?>
